<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.handle.handle_sample &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.handle.handle_sample</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.handle.handle_sample</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module ot handle samples (e.g., pandas dataframe)</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">List</span><span class="p">,</span> <span class="n">Union</span><span class="p">,</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Tuple</span>
<span class="kn">from</span> <span class="nn">.._typing</span> <span class="kn">import</span> <span class="n">ArrayLike</span>

<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">..config</span> <span class="kn">import</span> <span class="n">DICT_FCTS</span>


<div class="viewcode-block" id="compute_low_high"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_sample.compute_low_high">[docs]</a><span class="k">def</span> <span class="nf">compute_low_high</span><span class="p">(</span>
    <span class="n">samples</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">ArrayLike</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">ArrayLike</span><span class="p">]],</span>
    <span class="n">low</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">high</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">float</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="nb">float</span><span class="p">,</span> <span class="nb">float</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot; if low or high is/are not given, compute it/them.</span>

<span class="sd">    Args:</span>
<span class="sd">        samples: sample or list of samples</span>
<span class="sd">        low: low value of the range</span>
<span class="sd">        high: high value of the range</span>

<span class="sd">    Returns:</span>
<span class="sd">        low and high values of the samples, computed if not already computed.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Transform ``samples`` into a list of samples (if not already the case)</span>
    <span class="n">list_samples</span> <span class="o">=</span> <span class="p">[</span><span class="n">samples</span><span class="p">]</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">samples</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">)</span> <span class="k">else</span> <span class="n">samples</span>

    <span class="k">if</span> <span class="n">low</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">low</span> <span class="o">=</span> <span class="nb">min</span><span class="p">([</span><span class="nb">min</span><span class="p">(</span><span class="n">sample</span><span class="p">)</span> <span class="k">for</span> <span class="n">sample</span> <span class="ow">in</span> <span class="n">list_samples</span><span class="p">])</span>
    <span class="k">if</span> <span class="n">high</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">high</span> <span class="o">=</span> <span class="nb">max</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="n">sample</span><span class="p">)</span> <span class="k">for</span> <span class="n">sample</span> <span class="ow">in</span> <span class="n">list_samples</span><span class="p">])</span>

    <span class="k">return</span> <span class="n">low</span><span class="p">,</span> <span class="n">high</span></div>


<div class="viewcode-block" id="merge_columns"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_sample.merge_columns">[docs]</a><span class="k">def</span> <span class="nf">merge_columns</span><span class="p">(</span>
    <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span> <span class="n">columns</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span> <span class="n">merged_column</span><span class="p">:</span> <span class="nb">str</span>
<span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Merge columns of a dataframe, into one column, consisting of</span>
<span class="sd">    the values of the columns in a tuple. In-place.</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe: data sample</span>
<span class="sd">        columns: list of column names to merge</span>
<span class="sd">        merged_column: name of the resulting column</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dataframe</span><span class="p">[</span><span class="n">merged_column</span><span class="p">]</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span>
        <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="nb">tuple</span><span class="p">(</span><span class="n">dataframe</span><span class="p">[</span><span class="n">column</span><span class="p">]</span> <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">columns</span><span class="p">))</span>
    <span class="p">)</span></div>


<div class="viewcode-block" id="compute_columns"><a class="viewcode-back" href="../../../lib.handle.html#lib.handle.handle_sample.compute_columns">[docs]</a><span class="k">def</span> <span class="nf">compute_columns</span><span class="p">(</span>
        <span class="n">dataframe</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">,</span> <span class="n">list_columns</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span> <span class="nb">str</span><span class="p">]):</span>
    <span class="sd">&quot;&quot;&quot; Compute new columns defined with a function. Their names must</span>
<span class="sd">    be in the following format: ``{function_name}|{column}``. In-place.</span>
<span class="sd">    The functions are defined in the :py:mod:`config` module, in the</span>
<span class="sd">    dictionnary ``DICT_FCTS``.</span>

<span class="sd">    Args:</span>
<span class="sd">        dataframe: sample</span>
<span class="sd">        list_columns: list of columns to compute. The column names must</span>
<span class="sd">            contain a ``|`` character.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">list_columns</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
        <span class="n">list_columns</span> <span class="o">=</span> <span class="p">[</span><span class="n">list_columns</span><span class="p">]</span>
    <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">list_columns</span><span class="p">:</span>
        <span class="k">assert</span> <span class="s1">&#39;|&#39;</span> <span class="ow">in</span> <span class="n">column</span><span class="p">,</span> <span class="p">(</span><span class="sa">f</span><span class="s2">&quot;The column </span><span class="si">{column}</span><span class="s2"> should be in the &quot;</span>
                               <span class="s2">&quot;format ``</span><span class="si">{function_name}</span><span class="s2">|</span><span class="si">{column}</span><span class="s2">``&quot;</span><span class="p">)</span>

        <span class="n">fct_name</span><span class="p">,</span> <span class="n">origin_column</span> <span class="o">=</span> <span class="n">column</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;|&#39;</span><span class="p">)</span>
        <span class="k">assert</span> <span class="n">origin_column</span> <span class="ow">in</span> <span class="n">dataframe</span><span class="p">,</span> <span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{origin_column}</span><span class="s2"> is not in the&quot;</span>
                                            <span class="s2">&quot; input sample&quot;</span><span class="p">)</span>
        <span class="n">dataframe</span><span class="o">.</span><span class="n">loc</span><span class="p">[:,</span> <span class="n">column</span><span class="p">]</span> <span class="o">=</span> <span class="n">DICT_FCTS</span><span class="p">[</span><span class="n">fct_name</span><span class="p">](</span>
            <span class="n">dataframe</span><span class="p">[</span><span class="n">origin_column</span><span class="p">])</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>